# Marshall: A framework for pluggable marshalling policies
# Copyright (C) 2004-2006 Enfold Systems, LLC
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
"""
Interfaces for Predicate

$Id: predicate.py 5626 2006-01-24 02:26:47Z dreamcatcher $
"""

from Interface import Interface

class IPredicate(Interface):
    """ A Predicate """

    def apply(obj, **kw):
        """Return a sequence of component names
        if the predicate applies.
        """

    def getComponentName():
        """ Return the component name configured for
        this predicate.
        """

    def setComponentName(component_name):
        """ Change the component name """

    def setExpression(expression):
        """ Change the expression condition """

    def expression(context):
        """ Evaluate the expression using context """

    def getExpression():
        """ Get the expression as text """
